/*
 * orig_fs.h
 *
 * Copyright 2002, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#ifndef orig_fs_h
#define orig_fs_h


#ifndef ASM_FILE


enum{
	PT_TYPE_ORIG=0x9a,			/* Partition type numberʲ */
	SBLOCK_MAGIC=0xdddddddd,	/* superblock magic numberʲˡ */
	SBLOCK_SECTER=2,			/* ѡ֥åϥ */
	BLOCK_SIZE=1024,			/* ֥å礭Хˤʤ롢 */
};


/* Super block entry */
typedef struct{
	uint magic_number;		/* ޥȻγǧѥޥåʥС */
	int block_size;			/* ֥å */
	int blk_per_sect;		/* block size/secter size */
	size_t all_blk;			/* All blocks */
	size_t useable_blk;		/* Useable blocks */
	uint root_blk;			/* root block number */
	uint empty_blk;			/* ߤζ֥åǥå֥å */
}SUPER_BLOCK;

/* Directory top */
typedef struct{
	uint my_secter;			/* my block number */
	uint next_dir;			/* next directory link */
	uchar empty_top;		/* Top empty entry offset */
	char ent_topdir;		/* Top entry direcctory */
	ushort entry_top;		/* Top entry offset */
	int size;				/* directory size */
	ushort owner_id;		/* Owner UID */
	ushort group_id;		/* Group ID */
	uint64 access_time;		/* Last access time */
	uint64 create_time;		/* Create time */
	uint64 modificat_time;	/* Last modification time */
	int entry[0];			/* begin entry */
}DIR;

/* Directory empty entry */
typedef struct{
	int prev;		/* prev empty entry */
	int next;		/* next empty entry */
	int size;		/* entry size */
	int pad;		/* DIR_ENTƱˤ뤿ΤΡ */
}EMPTY_ENT;

/* ֥å */
typedef struct{
	uint next;			/* next empty block link */
	int current;		/* ֥åθ */
	uint empty[0];		/* ֥å */
}ENPTY_BLOCK;


#endif


#endif
